package sun.font;

import java.awt.font.GlyphJustificationInfo;
import java.awt.geom.Rectangle2D;

public abstract class ExtendedTextLabel extends TextLabel implements TextLineComponent
{
    public ExtendedTextLabel() {
    }
    
    @Override
    public abstract int getNumCharacters();
    
    @Override
    public abstract CoreMetrics getCoreMetrics();
    
    @Override
    public abstract float getCharX(int p0);
    
    @Override
    public abstract float getCharY(int p0);
    
    @Override
    public abstract float getCharAdvance(int p0);
    
    public abstract Rectangle2D getCharVisualBounds(int p0, float p1, float p2);
    
    public abstract int logicalToVisual(int p0);
    
    public abstract int visualToLogical(int p0);
    
    @Override
    public abstract int getLineBreakIndex(int p0, float p1);
    
    @Override
    public abstract float getAdvanceBetween(int p0, int p1);
    
    @Override
    public abstract boolean caretAtOffsetIsValid(int p0);
    
    @Override
    public Rectangle2D getCharVisualBounds(int n) {
        return this.getCharVisualBounds(n, 0.0f, 0.0f);
    }
    
    @Override
    public abstract TextLineComponent getSubset(int p0, int p1, int p2);
    
    @Override
    public abstract int getNumJustificationInfos();
    
    @Override
    public abstract void getJustificationInfos(GlyphJustificationInfo[] p0, int p1, int p2, int p3);
    
    @Override
    public abstract TextLineComponent applyJustificationDeltas(float[] p0, int p1, boolean[] p2);
}
